package com.goldencode.testcases.dmo.p2j_test.impl;

import java.io.Serializable;
import java.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.testcases.dmo.p2j_test.*;

/**
 * Data Model Object corresponding with table <code>p2j_test.vehicle</code>
 * (previously <code>p2j_test.vehicle</code>).
 */
@LegacyTable(name = "vehicle")
@LegacyIndexes(
{
   @LegacyIndex(name = "pi-make-model", converted = "vehicle_pi_make_model"),
   @LegacyIndex(name = "si-vin", converted = "vehicle_si_vin")
})
public class VehicleImpl
implements Serializable,
           Persistable,
           Vehicle
{
   /** Surrogate primary key */
   private Long id = null;

   /** Make; Manufacturer */
   @LegacyField(name = "make")
   private final character make1;

   /** Make; Manufacturer */
   @LegacyField(name = "make")
   private final character make2;

   /** Make; Manufacturer */
   @LegacyField(name = "make")
   private final character make3;

   /** Make; Manufacturer */
   @LegacyField(name = "make")
   private final character make4;

   /** Make; Manufacturer */
   @LegacyField(name = "make")
   private final character make5;

   /** Make; Manufacturer */
   @LegacyField(name = "make")
   private final character make6;

   /** Model; Vehicle model name */
   @LegacyField(name = "model")
   private final character model1;

   /** Number of axles; Number of axles */
   @LegacyField(name = "axles")
   private final integer axles1;

   /** Exterior; Exterior color */
   @LegacyField(name = "ext-color")
   private final character extColor1;

   /** VIN; Vehicle Identification Number */
   @LegacyField(name = "vin-number")
   private final character vinNumber1;

   /** VIN; Vehicle Identification Number */
   @LegacyField(name = "vin-number")
   private final character vinNumber2;

   /** VIN; Vehicle Identification Number */
   @LegacyField(name = "vin-number")
   private final character vinNumber3;

   /** Options; Optional features */
   @LegacyField(name = "options")
   private final character options1;

   /** Options; Optional features */
   @LegacyField(name = "options")
   private final character options2;

   /** Options; Optional features */
   @LegacyField(name = "options")
   private final character options3;

   /** Options; Optional features */
   @LegacyField(name = "options")
   private final character options4;

   /** Options; Optional features */
   @LegacyField(name = "options")
   private final character options5;

   /** Options; Optional features */
   @LegacyField(name = "options")
   private final character options6;

   /** Options; Optional features */
   @LegacyField(name = "options")
   private final character options7;

   /** Options; Optional features */
   @LegacyField(name = "options")
   private final character options8;

   /** Options; Optional features */
   @LegacyField(name = "options")
   private final character options9;

   /** Options; Optional features */
   @LegacyField(name = "options")
   private final character options10;

   /**
    * Default constructor.
    */
   public VehicleImpl()
   {
      make1 = new character("");
      make2 = new character("");
      make3 = new character("");
      make4 = new character("");
      make5 = new character("");
      make6 = new character("");
      model1 = new character("");
      axles1 = new integer(2);
      extColor1 = new character("");
      vinNumber1 = new character("");
      vinNumber2 = new character("");
      vinNumber3 = new character("");
      options1 = new character("");
      options2 = new character("");
      options3 = new character("");
      options4 = new character("");
      options5 = new character("");
      options6 = new character("");
      options7 = new character("");
      options8 = new character("");
      options9 = new character("");
      options10 = new character("");
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of
    *          this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new VehicleImpl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from
    * the given, backup instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      VehicleImpl from = (VehicleImpl) old;
      setId(from.getId());
      setMake1(from.getMake1());
      setMake2(from.getMake2());
      setMake3(from.getMake3());
      setMake4(from.getMake4());
      setMake5(from.getMake5());
      setMake6(from.getMake6());
      setModel1(from.getModel1());
      setAxles1(from.getAxles1());
      setExtColor1(from.getExtColor1());
      setVinNumber1(from.getVinNumber1());
      setVinNumber2(from.getVinNumber2());
      setVinNumber3(from.getVinNumber3());
      setOptions1(from.getOptions1());
      setOptions2(from.getOptions2());
      setOptions3(from.getOptions3());
      setOptions4(from.getOptions4());
      setOptions5(from.getOptions5());
      setOptions6(from.getOptions6());
      setOptions7(from.getOptions7());
      setOptions8(from.getOptions8());
      setOptions9(from.getOptions9());
      setOptions10(from.getOptions10());
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: Manufacturer
    * 
    * @return  Make
    */
   public character getMake1()
   {
      return (new character(make1));
   }

   /**
    * Setter: Manufacturer
    * 
    * @param   make1
    *          Make
    */
   public void setMake1(Text make1)
   {
      this.make1.assign(make1, true);
   }

   /**
    * Getter: Manufacturer
    * 
    * @return  Make
    */
   public character getMake2()
   {
      return (new character(make2));
   }

   /**
    * Setter: Manufacturer
    * 
    * @param   make2
    *          Make
    */
   public void setMake2(Text make2)
   {
      this.make2.assign(make2, true);
   }

   /**
    * Getter: Manufacturer
    * 
    * @return  Make
    */
   public character getMake3()
   {
      return (new character(make3));
   }

   /**
    * Setter: Manufacturer
    * 
    * @param   make3
    *          Make
    */
   public void setMake3(Text make3)
   {
      this.make3.assign(make3, true);
   }

   /**
    * Getter: Manufacturer
    * 
    * @return  Make
    */
   public character getMake4()
   {
      return (new character(make4));
   }

   /**
    * Setter: Manufacturer
    * 
    * @param   make4
    *          Make
    */
   public void setMake4(Text make4)
   {
      this.make4.assign(make4, true);
   }

   /**
    * Getter: Manufacturer
    * 
    * @return  Make
    */
   public character getMake5()
   {
      return (new character(make5));
   }

   /**
    * Setter: Manufacturer
    * 
    * @param   make5
    *          Make
    */
   public void setMake5(Text make5)
   {
      this.make5.assign(make5, true);
   }

   /**
    * Getter: Manufacturer
    * 
    * @return  Make
    */
   public character getMake6()
   {
      return (new character(make6));
   }

   /**
    * Setter: Manufacturer
    * 
    * @param   make6
    *          Make
    */
   public void setMake6(Text make6)
   {
      this.make6.assign(make6, true);
   }

   /**
    * Getter: Vehicle model name
    * 
    * @return  Model
    */
   public character getModel1()
   {
      return (new character(model1));
   }

   /**
    * Setter: Vehicle model name
    * 
    * @param   model1
    *          Model
    */
   public void setModel1(Text model1)
   {
      this.model1.assign(model1, true);
   }

   /**
    * Getter: Number of axles
    * 
    * @return  Number of axles
    */
   public integer getAxles1()
   {
      return (new integer(axles1));
   }

   /**
    * Setter: Number of axles
    * 
    * @param   axles1
    *          Number of axles
    */
   public void setAxles1(NumberType axles1)
   {
      this.axles1.assign(axles1, true);
   }

   /**
    * Getter: Exterior color
    * 
    * @return  Exterior
    */
   public character getExtColor1()
   {
      return (new character(extColor1));
   }

   /**
    * Setter: Exterior color
    * 
    * @param   extColor1
    *          Exterior
    */
   public void setExtColor1(Text extColor1)
   {
      this.extColor1.assign(extColor1, true);
   }

   /**
    * Getter: Vehicle Identification Number
    * 
    * @return  VIN
    */
   public character getVinNumber1()
   {
      return (new character(vinNumber1));
   }

   /**
    * Setter: Vehicle Identification Number
    * 
    * @param   vinNumber1
    *          VIN
    */
   public void setVinNumber1(Text vinNumber1)
   {
      this.vinNumber1.assign(vinNumber1, true);
   }

   /**
    * Getter: Vehicle Identification Number
    * 
    * @return  VIN
    */
   public character getVinNumber2()
   {
      return (new character(vinNumber2));
   }

   /**
    * Setter: Vehicle Identification Number
    * 
    * @param   vinNumber2
    *          VIN
    */
   public void setVinNumber2(Text vinNumber2)
   {
      this.vinNumber2.assign(vinNumber2, true);
   }

   /**
    * Getter: Vehicle Identification Number
    * 
    * @return  VIN
    */
   public character getVinNumber3()
   {
      return (new character(vinNumber3));
   }

   /**
    * Setter: Vehicle Identification Number
    * 
    * @param   vinNumber3
    *          VIN
    */
   public void setVinNumber3(Text vinNumber3)
   {
      this.vinNumber3.assign(vinNumber3, true);
   }

   /**
    * Getter: Optional features
    * 
    * @return  Options
    */
   public character getOptions1()
   {
      return (new character(options1));
   }

   /**
    * Setter: Optional features
    * 
    * @param   options1
    *          Options
    */
   public void setOptions1(Text options1)
   {
      this.options1.assign(options1, true);
   }

   /**
    * Getter: Optional features
    * 
    * @return  Options
    */
   public character getOptions2()
   {
      return (new character(options2));
   }

   /**
    * Setter: Optional features
    * 
    * @param   options2
    *          Options
    */
   public void setOptions2(Text options2)
   {
      this.options2.assign(options2, true);
   }

   /**
    * Getter: Optional features
    * 
    * @return  Options
    */
   public character getOptions3()
   {
      return (new character(options3));
   }

   /**
    * Setter: Optional features
    * 
    * @param   options3
    *          Options
    */
   public void setOptions3(Text options3)
   {
      this.options3.assign(options3, true);
   }

   /**
    * Getter: Optional features
    * 
    * @return  Options
    */
   public character getOptions4()
   {
      return (new character(options4));
   }

   /**
    * Setter: Optional features
    * 
    * @param   options4
    *          Options
    */
   public void setOptions4(Text options4)
   {
      this.options4.assign(options4, true);
   }

   /**
    * Getter: Optional features
    * 
    * @return  Options
    */
   public character getOptions5()
   {
      return (new character(options5));
   }

   /**
    * Setter: Optional features
    * 
    * @param   options5
    *          Options
    */
   public void setOptions5(Text options5)
   {
      this.options5.assign(options5, true);
   }

   /**
    * Getter: Optional features
    * 
    * @return  Options
    */
   public character getOptions6()
   {
      return (new character(options6));
   }

   /**
    * Setter: Optional features
    * 
    * @param   options6
    *          Options
    */
   public void setOptions6(Text options6)
   {
      this.options6.assign(options6, true);
   }

   /**
    * Getter: Optional features
    * 
    * @return  Options
    */
   public character getOptions7()
   {
      return (new character(options7));
   }

   /**
    * Setter: Optional features
    * 
    * @param   options7
    *          Options
    */
   public void setOptions7(Text options7)
   {
      this.options7.assign(options7, true);
   }

   /**
    * Getter: Optional features
    * 
    * @return  Options
    */
   public character getOptions8()
   {
      return (new character(options8));
   }

   /**
    * Setter: Optional features
    * 
    * @param   options8
    *          Options
    */
   public void setOptions8(Text options8)
   {
      this.options8.assign(options8, true);
   }

   /**
    * Getter: Optional features
    * 
    * @return  Options
    */
   public character getOptions9()
   {
      return (new character(options9));
   }

   /**
    * Setter: Optional features
    * 
    * @param   options9
    *          Options
    */
   public void setOptions9(Text options9)
   {
      this.options9.assign(options9, true);
   }

   /**
    * Getter: Optional features
    * 
    * @return  Options
    */
   public character getOptions10()
   {
      return (new character(options10));
   }

   /**
    * Setter: Optional features
    * 
    * @param   options10
    *          Options
    */
   public void setOptions10(Text options10)
   {
      this.options10.assign(options10, true);
   }
}
